// Apfelteig Patch ;-)

#include "stdafx.h"
#include "emule.h"
#include "PPgHTTPD.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


#define HIDDEN_PASSWORD _T("*****")

IMPLEMENT_DYNAMIC(CPPgHTTPD, CPropertyPage)
CPPgHTTPD::CPPgHTTPD()
	: CPropertyPage(CPPgHTTPD::IDD)
{
}

CPPgHTTPD::~CPPgHTTPD()
{
}

void CPPgHTTPD::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
}
BEGIN_MESSAGE_MAP(CPPgHTTPD, CPropertyPage)
	ON_EN_CHANGE(IDC_HTTPDPASS, OnEnChangeHTTPDPass)
	ON_EN_CHANGE(IDC_HTTPDPORT, OnEnChangeHTTPDPort)
	ON_BN_CLICKED(IDC_HTTPDENABLED, OnEnChangeHTTPDEnabled)
	ON_BN_CLICKED(IDC_HTTPDRELOADTMPL, OnReloadTemplates)
END_MESSAGE_MAP()

BOOL CPPgHTTPD::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	((CEdit*)GetDlgItem(IDC_HTTPDPASS))->SetLimitText(12);
	((CEdit*)GetDlgItem(IDC_HTTPDPORT))->SetLimitText(6);

	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgHTTPD::LoadSettings(void)
{
	CString strBuffer;

	GetDlgItem(IDC_HTTPDPASS)->SetWindowText(HIDDEN_PASSWORD);
	strBuffer.Format("%d", app_prefs->GetHTTPPort());
	GetDlgItem(IDC_HTTPDPORT)->SetWindowText(strBuffer);
	if(app_prefs->GetHTTPIsEnabled())
		CheckDlgButton(IDC_HTTPDENABLED,1);
	else
		CheckDlgButton(IDC_HTTPDENABLED,0);
	OnEnChangeHTTPDEnabled();

	SetModified(FALSE);	// FoRcHa
}

BOOL CPPgHTTPD::OnApply()
{	
//	CSingleLock PrefLock(&(app_prefs->m_Pref_Mutex),TRUE); 

	if(m_bModified)
	{
		CString sBuf;
		GetDlgItem(IDC_HTTPDPASS)->GetWindowText(sBuf);
		if(sBuf != HIDDEN_PASSWORD)
			app_prefs->SetHTTPPass(sBuf);
			//strcpy(app_prefs->prefs->httppassword, MD5Sum(sBuf).GetHash());

		GetDlgItem(IDC_HTTPDPORT)->GetWindowText(sBuf);
		if((bool)IsDlgButtonChecked(IDC_HTTPDENABLED)!=app_prefs->GetHTTPIsEnabled())
		{
			app_prefs->SetHTTPIsEnabled((int8)IsDlgButtonChecked(IDC_HTTPDENABLED));
			theApp.webserver->StartServer();
		}
		if (atoi(sBuf)-app_prefs->GetHTTPPort()!=0)
		{
			app_prefs->SetHTTPPort(atoi(sBuf));
			theApp.webserver->RestartServer();	//Cax2 - restarts the server with the new port settings
		}
		

		SetModified(FALSE);
	}

	return CPropertyPage::OnApply();
}

void CPPgHTTPD::Localize(void)
{
	if(m_hWnd){
		SetWindowText(GetResString(IDS_PW_HTTPD));
		GetDlgItem(IDC_HTTPDPASS_LBL)->SetWindowText(GetResString(IDS_HTTPD_PASS));
		GetDlgItem(IDC_HTTPDPORT_LBL)->SetWindowText(GetResString(IDS_PORT));
		GetDlgItem(IDC_HTTPDENABLED)->SetWindowText(GetResString(IDS_ENABLED));
		GetDlgItem(IDC_HTTPDRELOADTMPL)->SetWindowText(GetResString(IDS_HTTPD_RELOAD_TMPL));
	}
}

void CPPgHTTPD::OnEnChangeHTTPDEnabled()
{
	GetDlgItem(IDC_HTTPDPASS)->EnableWindow(IsDlgButtonChecked(IDC_HTTPDENABLED));	
	GetDlgItem(IDC_HTTPDPORT)->EnableWindow(IsDlgButtonChecked(IDC_HTTPDENABLED));	
	GetDlgItem(IDC_HTTPDRELOADTMPL)->EnableWindow(IsDlgButtonChecked(IDC_HTTPDENABLED)); // EC

/*	// performed in WebServer.cpp
	if(IsDlgButtonChecked(IDC_HTTPDENABLED))
	{
		AddLogLine(false,"%s: %s",GetResString(IDS_PW_HTTPD), GetResString(IDS_ENABLED).MakeLower());
	} else {
		AddLogLine(false,"%s: %s",GetResString(IDS_PW_HTTPD), GetResString(IDS_DISABLED).MakeLower());
	}
*/
	SetModified();
}

void CPPgHTTPD::OnReloadTemplates()
{
	theApp.webserver->ReloadTemplates();
}
