//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


// SearchDlg.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "SearchDlg.h"
#include "packets.h"
#include "server.h"
#include "opcodes.h"
#include "otherfunctions.h"
#include "ED2KLink.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// CSearchDlg dialog

IMPLEMENT_DYNAMIC(CSearchDlg, CDialog)
CSearchDlg::CSearchDlg(CWnd* pParent /*=NULL*/)
: CResizableDialog(CSearchDlg::IDD, pParent)
{
	m_nSearchID = 0;
	searchpacket	=	NULL;
}

CSearchDlg::~CSearchDlg()
{
	if ( searchpacket )
		delete searchpacket;
}

BOOL CSearchDlg::OnInitDialog()
{
	CResizableDialog::OnInitDialog();
	theApp.searchlist->SetOutputWnd(&searchlistctrl);
	searchlistctrl.Init(theApp.searchlist);
	searchprogress.SetStep(1);
	global_search_timer = 0;
	globsearch = false;

	m_ctrlSearchFrm.Init(IDI_NORMALSEARCH, &theApp.emuledlg->m_ThemeHelper);
	m_ctrlDirectDlFrm.Init(IDI_DIRECTDOWNLOAD, &theApp.emuledlg->m_ThemeHelper);	
	oldSearchLstIcon = GetSearchLstStatic()->SetIcon(GetSearchLstIcon());	//[TwoBottle Mod]

	searchselect.ShowWindow(SW_HIDE);
	m_BoxImageList.Create(13,13,ILC_COLOR32|ILC_MASK,0,10);
	m_BoxImageList.SetBkColor(CLR_NONE);
	m_BoxImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_SCH_SERVER),13,13));
	m_BoxImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_SCH_GLOBAL),13,13));
	m_BoxImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_SCH_FILEDONKEY),13,13));
	m_BoxImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_SCH_JIGLE),13,13));

	m_ImageList.Create(16,16,ILC_COLOR32|ILC_MASK,0,10);
	m_ImageList.SetBkColor(CLR_NONE);
	m_ImageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_NORMALSEARCH),16,16));
	LoadImgLstIcon(NULL,0,0); // delete temp-icon
	searchselect.SetImageList(&m_ImageList);

	AddAnchor(IDC_SEARCH_FRM, TOP_LEFT);
	AddAnchor(IDC_SNAME_LBL, TOP_LEFT);
	AddAnchor(IDC_SEARCHNAME, TOP_LEFT);
	AddAnchor(IDC_STYPE_LBL, TOP_LEFT);
	AddAnchor(IDC_TypeSearch, TOP_LEFT);
	AddAnchor(IDC_SMETHOD_LBL, TOP_LEFT);
	AddAnchor(IDC_METHOD, TOP_LEFT);

	AddAnchor(IDC_DDOWN_FRM, TOP_LEFT, TOP_RIGHT);
	AddAnchor(IDC_ED2KLINK_LBL, TOP_LEFT);
	AddAnchor(IDC_ELINK, TOP_LEFT, TOP_RIGHT);

	AddAnchor(IDC_STARTS, TOP_RIGHT);
	AddAnchor(IDC_CANCELS, TOP_RIGHT);
	AddAnchor(IDC_CLEARALL, TOP_RIGHT);

	AddAnchor(IDC_SEARCHLST_ICO, TOP_LEFT);
	AddAnchor(IDC_RESULTS_LBL, TOP_LEFT);
	AddAnchor(IDC_SEARCHLIST, TOP_LEFT, BOTTOM_RIGHT);

	AddAnchor(IDC_SDOWNLOAD,BOTTOM_RIGHT);
	AddAnchor(IDC_SMARTF_LBL,BOTTOM_LEFT);
	AddAnchor(IDC_EDITSEARCHEXTENSION,BOTTOM_LEFT);
	AddAnchor(IDC_PROGRESS1,BOTTOM_LEFT,BOTTOM_RIGHT);

	AddAnchor(searchselect.m_hWnd,TOP_LEFT,TOP_RIGHT);
	AddAnchor(IDC_DOWNLOAD_ALL_ED2K, BOTTOM_RIGHT); //<<-- enkeyDEV(Ottavio84) -Download all ed2ks in clipboard-

	Localize();
	return true;
}

void CSearchDlg::DoDataExchange(CDataExchange* pDX)
{
	CResizableDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SEARCHLIST, searchlistctrl);
	DDX_Control(pDX, IDC_PROGRESS1, searchprogress);
	DDX_Control(pDX, IDC_METHOD, methodbox);
	DDX_Control(pDX, IDC_TypeSearch, Stypebox);
	DDX_Control(pDX, IDC_TAB1, searchselect);
	DDX_Control(pDX, IDC_SEARCH_FRM, m_ctrlSearchFrm);
	DDX_Control(pDX, IDC_DDOWN_FRM, m_ctrlDirectDlFrm);
}


BEGIN_MESSAGE_MAP(CSearchDlg, CResizableDialog)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_SEARCH_RESET, OnBnClickedSearchReset)
	ON_BN_CLICKED(IDC_STARTS, OnBnClickedStarts)
	ON_BN_CLICKED(IDC_CANCELS, OnBnClickedCancels)
	ON_BN_CLICKED(IDC_CLEARALL, OnBnClickedClearall)
	ON_BN_CLICKED(IDC_SDOWNLOAD, OnBnClickedSdownload)
	ON_BN_CLICKED(IDC_DOWNLOAD_ALL_ED2K, OnBnClickedDownloadAllEd2k)
	ON_EN_CHANGE(IDC_SEARCHNAME, OnEnChangeSearchname)
	ON_EN_CHANGE(IDC_SEARCHAVAIL , OnEnChangeSearchname)
	ON_EN_CHANGE(IDC_SEARCHEXTENSION, OnEnChangeSearchname)
	ON_EN_KILLFOCUS(IDC_EDITSEARCHMIN, OnChangeMin)
	ON_EN_KILLFOCUS(IDC_EDITSEARCHMAX, OnChangeMax)
	ON_NOTIFY(NM_DBLCLK, IDC_SEARCHLIST, OnNMDblclkSearchlist)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB1, OnTcnSelchangeTab1)
	ON_CBN_SELCHANGE(IDC_TypeSearch, OnEnChangeSearchname)
	ON_CBN_SELCHANGE(IDC_METHOD, OnEnChangeMethod)
	ON_MESSAGE(WM_CLOSETAB, OnCloseTab)
	ON_STN_CLICKED(IDC_SEARCHEXTENSION_LBL, OnStnClickedSearchextensionLbl)
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// CSearchDlg message handlers
void CSearchDlg::OnChangeMin()
{
	OnChangeSize(true);
}
void CSearchDlg::OnChangeMax()
{
	OnChangeSize(false);
}

void CSearchDlg::OnChangeSize(bool changedMin)
{
	CString sMin, sMax;
	GetDlgItem(IDC_EDITSEARCHMIN)->GetWindowText(sMin);
	GetDlgItem(IDC_EDITSEARCHMAX)->GetWindowText(sMax);
	if (atol(sMin)>2047)
		GetDlgItem(IDC_EDITSEARCHMIN)->SetWindowText("2047");
	if (atol(sMax)>2048)
		GetDlgItem(IDC_EDITSEARCHMAX)->SetWindowText("2048");
	if (atoi(sMax)-atoi(sMin)<1 && sMax!="")
	{
		if (changedMin)
		{
			GetDlgItem(IDC_EDITSEARCHMAX)->SetWindowText("");	
		}
		else
		{
			GetDlgItem(IDC_EDITSEARCHMIN)->SetWindowText("");
		}
	}
	OnEnChangeSearchname();
}

void CSearchDlg::OnBnClickedStarts()
{
	searchprogress.SetPos(0);

	if (GetDlgItem(IDC_ELINK)->GetWindowTextLength())
	{
		CString strlink;
		GetDlgItem(IDC_ELINK)->GetWindowText(strlink);
		if (strlink.Right(1)!="/") strlink+="/";
		GetDlgItem(IDC_ELINK)->SetWindowText("");
		try 
		{
			CED2KLink* pLink = CED2KLink::CreateLinkFromUrl(strlink);
			_ASSERT( pLink !=0 );
			if ( pLink->GetKind() == CED2KLink::kFile)
			{
				theApp.downloadqueue->AddFileLinkToDownload(pLink->GetFileLink());
			} else {
				delete pLink; // [i_a] memleak
				throw CString("bad link");
			}
			delete pLink;
		} catch(CString &error) {
			OUTPUT_DEBUG_TRACE();
			char buffer[200];
			sprintf(buffer,GetResString(IDS_ERR_INVALIDLINK),error.GetBuffer());
			AddLogLine(true, GetResString(IDS_ERR_LINKERROR), buffer);
		}
		return;
	}
	if (GetDlgItem(IDC_SEARCHNAME)->GetWindowTextLength())
	{
		switch (methodbox.GetCurSel())
		{
		case 0:
		case 1:
			StartNewSearch();
			break;

		case 2:
		case 3:
			ShellOpenFile(CreateWebQuery());
			return;
		default:
			return;
		}
	}
}

void CSearchDlg::OnTimer(UINT nIDEvent)
{
	CResizableDialog::OnTimer(nIDEvent);
	if (theApp.serverconnect->IsConnected())
	{
		CServer* toask = theApp.serverlist->GetNextSearchServer();
		if (toask == theApp.serverlist->GetServerByAddress(theApp.serverconnect->GetCurrentServer()->GetAddress(),theApp.serverconnect->GetCurrentServer()->GetPort()))
			toask = theApp.serverlist->GetNextSearchServer();

		if (toask && theApp.serverlist->GetServerCount()-1 != servercount)
		{
			servercount++;
			theApp.serverconnect->SendUDPPacket(searchpacket,toask,false);
			searchprogress.StepIt();
		}
		else
			OnBnClickedCancels();
	}
	else
		OnBnClickedCancels();
}

void CSearchDlg::OnBnClickedCancels()
{
	canceld = true;
	globsearch = false;
	if (global_search_timer)
	{
		delete searchpacket;
		searchpacket	=	NULL;
		KillTimer(global_search_timer);
		global_search_timer = 0;
		searchprogress.SetPos(0);
	}
	GetDlgItem(IDC_CANCELS)->EnableWindow(false);
	GetDlgItem(IDC_STARTS)->EnableWindow(true);
	GetDlgItem(IDC_CLEARALL)->EnableWindow(true);
}


void CSearchDlg::LocalSearchEnd(uint16 count)
{
	if (!canceld && count > MAX_RESULTS)
		OnBnClickedCancels();
	if (!canceld){	
		if (!globsearch)
		{
			GetDlgItem(IDC_STARTS)->EnableWindow(true);
			GetDlgItem(IDC_CANCELS)->EnableWindow(false);
			GetDlgItem(IDC_CLEARALL)->EnableWindow(true);
		}
		else
			global_search_timer = SetTimer(1, 750, 0);

	}
}
void CSearchDlg::AddUDPResult(uint16 count)
{
	if (!canceld && count > MAX_RESULTS)
		OnBnClickedCancels();
}

void CSearchDlg::OnBnClickedSdownload()
{
	DownloadSelected();
}

BOOL CSearchDlg::PreTranslateMessage(MSG* pMsg) 
{
	if((pMsg->message == WM_KEYDOWN) && (pMsg->wParam == 13))
	{
		if (pMsg->hwnd == GetDlgItem(IDC_SEARCHLIST)->m_hWnd)
			OnBnClickedSdownload();
		else if (pMsg->hwnd == GetDlgItem(IDC_ELINK)->m_hWnd)
			OnBnClickedStarts();
		else if (pMsg->hwnd == GetDlgItem(IDC_SEARCHNAME)->m_hWnd || 
			pMsg->hwnd == GetDlgItem(IDC_TypeSearch)->m_hWnd || 
			pMsg->hwnd == GetDlgItem(IDC_EDITSEARCHMIN)->m_hWnd || 
			pMsg->hwnd == GetDlgItem(IDC_EDITSEARCHMAX)->m_hWnd || 
			pMsg->hwnd == GetDlgItem(IDC_EDITSEARCHAVAIBILITY)->m_hWnd || 
			pMsg->hwnd == GetDlgItem(IDC_EDITSEARCHEXTENSION)->m_hWnd)
			OnBnClickedStarts();
	}
	return CResizableDialog::PreTranslateMessage(pMsg);
}

void CSearchDlg::OnNMDblclkSearchlist(NMHDR *pNMHDR, LRESULT *pResult)
{
	OnBnClickedSdownload();
	*pResult = 0;
}

CString	CSearchDlg::CreateWebQuery()
{
	CString query,tosearch;
	unsigned long num;
	switch (methodbox.GetCurSel())
	{
	case 2:
		query = "http://www.filedonkey.com/fdsearch/index.php?";
		GetDlgItem(IDC_SEARCHNAME)->GetWindowText(tosearch);
		query += "pattern="+ToQueryString(tosearch);
		GetDlgItem(IDC_TypeSearch)->GetWindowText(tosearch);
		if (GetResString(IDS_SEARCH_AUDIO)==tosearch)
			tosearch="Audio";
		else if (GetResString(IDS_SEARCH_VIDEO)==tosearch)
			tosearch="Video";
		else if (GetResString(IDS_SEARCH_PRG)==tosearch)
			tosearch="Pro";
		else
			tosearch="All";
		query +="&media=" + tosearch; //Cax2 added filedonkey 'type' option
		query += "&action=search&name=FD-Search&op=modload&file=index&requestby=emule";
		break;
	case 3:
		query = "http://www.jigle.com/search?";
		GetDlgItem(IDC_SEARCHNAME)->GetWindowText(tosearch);
		query += "p="+ToQueryString(tosearch) + "&ma=";
		GetDlgItem(IDC_EDITSEARCHAVAIBILITY)->GetWindowText(tosearch);
		if (atol(tosearch)>1000) tosearch="1000";
		else if (atoi(tosearch)>500) tosearch="500";
		else if (atoi(tosearch)>200) tosearch="200";
		else if (atoi(tosearch)>100) tosearch="100";
		else if (atoi(tosearch)>50) tosearch="50";
		else if (atoi(tosearch)>20) tosearch="20";
		else if (atoi(tosearch)>10) tosearch="10";
		else tosearch="1";
		query += tosearch +"&v=0&d=1&a=0&l=10";		//Cax2 might want to change to l=25 for more results per page... 
		GetDlgItem(IDC_TypeSearch)->GetWindowText(tosearch);
		if (GetResString(IDS_SEARCH_AUDIO)==tosearch)
			tosearch="1";
		else if (GetResString(IDS_SEARCH_VIDEO)==tosearch)
			tosearch="2";
		else if (GetResString(IDS_SEARCH_PICS)==tosearch)
			tosearch="3";
		else if (GetResString(IDS_SEARCH_PRG)==tosearch)
			tosearch="4";
		else
			tosearch="0";
		query +="&t=" +tosearch;
		GetDlgItem(IDC_EDITSEARCHEXTENSION)->GetWindowText(tosearch);
		query +="&x=" + ToQueryString(tosearch);
		GetDlgItem(IDC_EDITSEARCHMIN)->GetWindowText(tosearch);
		num=atol(tosearch);
		tosearch.Format("%u",((num>0)?num *1048576:1));
		query +="&sl=" +tosearch;
		GetDlgItem(IDC_EDITSEARCHMAX)->GetWindowText(tosearch);
		num=atol(tosearch);
		tosearch.Format(((num>0)?"%u":""),num * 1048576);
		query +="&su=" + tosearch;
		break;
	default:
		return "";
	}
	return query;
}

CString	CSearchDlg::ToQueryString(CString str){
	CString sTmp = URLEncode(str);
	sTmp.Replace("%20","+");
	return sTmp;
}


void CSearchDlg::DownloadSelected()
{
	int index = -1; 
	POSITION pos = searchlistctrl.GetFirstSelectedItemPosition(); 
	while(pos != NULL) 
	{ 
		index = searchlistctrl.GetNextSelectedItem(pos); 
		if(index > -1)
		{
			theApp.downloadqueue->AddSearchToDownload((CSearchFile*)searchlistctrl.GetItemData(index));
			// Lord KiRon
			//searchlistctrl.Update(index);
			searchlistctrl.RedrawItems(index,index);
		}
	} 
}


void CSearchDlg::Localize()
{
	searchlistctrl.Localize();

	m_ctrlSearchFrm.SetText(GetResString(IDS_SW_SEARCHBOX));
	GetDlgItem(IDC_SNAME_LBL)->SetWindowText(GetResString(IDS_SW_NAME));
	GetDlgItem(IDC_STYPE_LBL)->SetWindowText(GetResString(IDS_SW_TYPE));
	GetDlgItem(IDC_SMETHOD_LBL)->SetWindowText(GetResString(IDS_SW_METHOD));
	m_ctrlDirectDlFrm.SetText(GetResString(IDS_SW_DIRECTDOWNLOAD));
	GetDlgItem(IDC_ED2KLINK_LBL)->SetWindowText(GetResString(IDS_SW_LINK));

	GetDlgItem(IDC_STARTS)->SetWindowText(GetResString(IDS_SW_START));
	GetDlgItem(IDC_CANCELS)->SetWindowText(GetResString(IDS_SW_CANCEL));
	GetDlgItem(IDC_CLEARALL)->SetWindowText(GetResString(IDS_REMOVEALLSEARCH));

	GetDlgItem(IDC_RESULTS_LBL)->SetWindowText(GetResString(IDS_SW_RESULT));
	GetDlgItem(IDC_SDOWNLOAD)->SetWindowText(GetResString(IDS_SW_DOWNLOAD));

	GetDlgItem(IDC_SEARCHMINSIZE)->SetWindowText(GetResString(IDS_SEARCHMINSIZE) + " (" + GetResString(IDS_MBYTES) + ")");
	GetDlgItem(IDC_SEARCHMAXSIZE)->SetWindowText(GetResString(IDS_SEARCHMAXSIZE) + " (" + GetResString(IDS_MBYTES) + ")");
	//GetDlgItem(IDC_SEARCHEXTENSION_LBL)->SetWindowText(GetResString(IDS_SEARCHEXTENSION_LBL));
	GetDlgItem(IDC_SEARCHAVAIL)->SetWindowText(GetResString(IDS_SEARCHAVAIL));
	GetDlgItem(IDC_SEARCH_RESET)->SetWindowText(GetResString(IDS_PW_RESET)); // EC
	GetDlgItem(IDC_SMARTFILTER_LBL)->SetWindowText(GetResString(IDS_SMARTFILTER_LBL)); // EC
	GetDlgItem(IDC_DOWNLOAD_ALL_ED2K)->SetWindowText(GetResString(IDS_DOWNLOAD_ALL_ED2K)); //<<--enkeyDEV

	methodbox.ResetContent();
	methodbox.SetImageList(&m_BoxImageList);
	COMBOBOXEXITEM     cbi;
	cbi.mask = CBEIF_IMAGE | CBEIF_OVERLAY | CBEIF_SELECTEDIMAGE | CBEIF_TEXT;
	CString            str[4];
	str[0]=GetResString(IDS_PW_SERVER);
	str[1]=GetResString(IDS_SW_GLOBAL);
	str[2]="FileDonkey";
	str[3]="Jigle";
	for (int i=0; i<4;i++)
	{
		cbi.iItem = i;
		cbi.pszText = (LPTSTR)(LPCTSTR)str[i];
		cbi.cchTextMax = str[i].GetLength();
		cbi.iImage = i;
		cbi.iSelectedImage = i;
		cbi.iOverlay = i;
		methodbox.InsertItem(&cbi);
	}
	methodbox.SetCurSel(theApp.glob_prefs->GetMethod());

	Stypebox.ResetContent();
	Stypebox.AddString(GetResString(IDS_SEARCH_ANY));
	Stypebox.AddString(GetResString(IDS_SEARCH_ARC)+" (.zip .rar .ace...)");
	Stypebox.AddString(GetResString(IDS_SEARCH_AUDIO)+" (.mp3 .ogg .wav...)");
	Stypebox.AddString(GetResString(IDS_SEARCH_CDIMG)+" (.iso .bin .nrg...)");
	Stypebox.AddString(GetResString(IDS_SEARCH_PICS)+" (.jpg .gif .png...)");
	Stypebox.AddString(GetResString(IDS_SEARCH_PRG)+" (.exe .zip .rar...)");
	Stypebox.AddString(GetResString(IDS_SEARCH_VIDEO)+" (.avi .mpg .ogm...)");
	//Stypebox.AddString(GetResString(IDS_SEARCH_USER));
	Stypebox.SetCurSel(0);
}

void CSearchDlg::OnBnClickedClearall()
{
	OnBnClickedCancels();
	DeleteAllSearchs();
}

void CSearchDlg::StartNewSearch()
{
	bool isThisGlobal=(methodbox.GetCurSel()==1);
	if (!theApp.serverconnect->IsConnected())
		MessageBox(GetResString(IDS_ERR_NOTCONNECTED),GetResString(IDS_NOTCONNECTED),64);
	else{
		m_nSearchID++;
		CString typeText;
		CString searchString;
		GetDlgItem(IDC_TypeSearch)->GetWindowText(typeText);
		int idx=typeText.Find(" (.");	//Cax2 bugfix: remove all examples from typeText
		if (idx>0)
			typeText.Delete(idx,typeText.GetLength()-idx);
		GetDlgItem(IDC_SEARCHNAME)->GetWindowText(searchString);
		theApp.searchlist->NewSearch(&searchlistctrl,typeText,m_nSearchID);
		GetDlgItem(IDC_STARTS)->EnableWindow(false);
		GetDlgItem(IDC_CANCELS)->EnableWindow(true);
		canceld = false;

		long typeNemonic=  0x00030001;
		long extensionNemonic= 0x00040001;
		long avaibilityNemonic=0x15000101;
		long minNemonic=       0x02000101;
		long maxNemonic=	   0x02000102;
		byte stringParameter=1;
		byte typeParameter=2;
		byte numericParameter=3;
		int andParameter=0x0000;
		int orParameter=0x0100;

		CMemFile* data = new CMemFile(100); 
		uint16 nSize;
		char* formatC;
		unsigned long avaibility;

		CString sizeMin,sizeMax,extension,avaibilitystr,type;
		GetDlgItem(IDC_EDITSEARCHMIN)->GetWindowText(sizeMin);
		GetDlgItem(IDC_EDITSEARCHMAX)->GetWindowText(sizeMax);
		unsigned long max=atol(sizeMax.GetString())*1048576; 
		unsigned long min=atol(sizeMin.GetString())*1048576; 
		if (max==0 || max<min) max=2147483646;//max file size 
		//Keep the code, we might want to re-enable an extension box in the future...
		//GetDlgItem(IDC_EDITSEARCHEXTENSION)->GetWindowText(extension);
		//if (extension.GetLength()>0 && extension.GetAt(0)!='.' ) extension="."+extension;
		type="";
		if (GetResString(IDS_SEARCH_AUDIO)==typeText) type="Audio"; 
		if (GetResString(IDS_SEARCH_VIDEO)==typeText) type="Video";
		//archives and programs treated the same by servers
		if (GetResString(IDS_SEARCH_ARC)==typeText||GetResString(IDS_SEARCH_PRG)==typeText) type="Pro"; 
		if (GetResString(IDS_SEARCH_PICS)==typeText) type="Image"; 

		GetDlgItem(IDC_EDITSEARCHAVAIBILITY)->GetWindowText(avaibilitystr); 
		avaibility=atol(avaibilitystr.GetString());

		if ( searchString.GetLength()==0 && extension.GetLength()==0) 
		{
			delete data;
			return;
		}

		int parametercount=0; //must be written parametercount-1 parmeter headers

		//Cax2 - get users: no other parameters allowed
		//Get users TODO - still need to display the results sent by the server!!!
		if(GetResString(IDS_SEARCH_USER)!=typeText)
		{
			if ( searchString.GetLength()>0)
			{
			parametercount++;
			if (parametercount>1)
				data->Write(&andParameter,2);
			}

		if (type.GetLength()>0)
			{
			parametercount++;
			if (parametercount>1)
				data->Write(&andParameter,2);
			}
		  
			if (min>0)
			{
			parametercount++;
			if (parametercount>1)
				data->Write(&andParameter,2);
			}
	        
			if (max>0)
			{
			parametercount++;
			if (parametercount>1)
				data->Write(&andParameter,2);
			}
	        
			if (avaibility>0)
			{
			parametercount++;
			if (parametercount>1)
				data->Write(&andParameter,2);
			}
	        
			if (extension.GetLength()>0)
			{
			parametercount++;
			if (parametercount>1)
				data->Write(&andParameter,2);
			}
		}

		//body
		if (!searchString.IsEmpty()) //search a string
		{
			data->Write(&stringParameter,1); //write the parameter type
			nSize = searchString.GetLength(); 
			data->Write(&nSize,2);  // write parameter length
			formatC=searchString.GetBuffer(); 
			data->Write(formatC,nSize); //write the searched string 
		}
		//Cax2 - get users: no other parameters allowed
		if(GetResString(IDS_SEARCH_USER)!=typeText)
		{
			if (!type.IsEmpty())
			{
				data->Write(&typeParameter,1); //write the parameter type
				nSize=type.GetLength(); 
				data->Write(&nSize,2);   //write the length
				formatC=type.GetBuffer(); 
				data->Write(formatC,nSize); //write parameter
				data->Write(&typeNemonic,3); //mnemonic for this kind of parameter (only 3 bytes!!)
			}

			if (min>0)
			{
				data->Write(&numericParameter,1); //write the parameter type
				data->Write(&min,4);		   //write the parameter
				data->Write(&minNemonic,4);    //nemonic for this kind of parameter
			}

			if (max>0)
			{
				data->Write(&numericParameter,1); //write the parameter type
				data->Write(&max,4);		   //write the parameter
				data->Write(&maxNemonic,4);    //nemonic for this kind of parameter
			}

			if (avaibility>0)
			{
				data->Write(&numericParameter,1); //write the parameter type
				data->Write(&avaibility,4);    //write the parameter
				data->Write(&avaibilityNemonic,4);  //nemonic for this kind of parameter
			}

			if (extension.GetLength()>0)
			{
				data->Write(&stringParameter,1); //write the parameter type
				nSize=extension.GetLength(); 
				data->Write(&nSize,2);   //write the length
				formatC=extension.GetBuffer(); 
				data->Write(formatC,nSize); //write parameter
				data->Write(&extensionNemonic,3); //nemonic for this kind of parameter (only 3 bytes!!)
			}
		}

		Packet* packet = new Packet(data);
		if ( packet )
		{
			//Cax2 - get users
			packet->opcode =(GetResString(IDS_SEARCH_USER)==typeText)?OP_SEARCH_USER:OP_SEARCHREQUEST;
			delete data;
			theApp.uploadqueue->AddUpDataOverheadServer(packet->size);
			theApp.serverconnect->SendPacket(packet,false);

			if (isThisGlobal){
				if( theApp.glob_prefs->Score() ){
					theApp.serverlist->ResetSearchServerPos();
				}
				if ( searchpacket )
				{
					delete searchpacket;
				}
				searchpacket = packet;
				searchpacket->opcode = OP_GLOBSEARCHREQ;
				servercount = 0;
				searchprogress.SetRange32(0,theApp.serverlist->GetServerCount()-1);
				globsearch = true;
			}
			else{
				globsearch = false;
				delete packet;
			}
			CreateNewTab(searchString,m_nSearchID);
		}
	}
}

void CSearchDlg::CreateNewTab(CString searchString,uint32 nSearchID)
{
	// add new tab
	TCITEM newitem;
	if (searchString.GetLength() == 0)
		searchString = "-";
	newitem.mask = TCIF_PARAM|TCIF_TEXT|TCIF_IMAGE;
	newitem.lParam = (LPARAM)nSearchID;
	newitem.pszText = searchString.GetBuffer();
	newitem.cchTextMax = (int)searchString.GetLength()+10;
	newitem.iImage = 0;
	uint16 itemnr = searchselect.InsertItem(searchselect.GetItemCount(),&newitem);
	if (!searchselect.IsWindowVisible())
		searchselect.ShowWindow(SW_SHOW);
	searchselect.SetCurSel(itemnr);
	searchlistctrl.ShowResults(nSearchID);
}

void CSearchDlg::DeleteSearch(uint32 nSearchID)
{
	TCITEM item;
	item.mask = TCIF_PARAM;
	int i;
	for (i = 0; i != searchselect.GetItemCount();i++)
	{
		searchselect.GetItem(i,&item);
		if (item.lParam == nSearchID)
			break;
	}
	if (item.lParam != nSearchID)
		return;
	if ((!canceld) && (nSearchID == m_nSearchID))
		OnBnClickedCancels();  //Sony - cancel active search before closing active tab
	theApp.searchlist->RemoveResults(nSearchID);
	searchselect.DeleteItem(i);
	if (searchselect.GetItemCount())
	{
		searchselect.SetCurSel(0);
		item.mask = TCIF_PARAM;
		searchselect.GetItem(0,&item);
		searchlistctrl.ShowResults(item.lParam);
	}
	else
	{
		searchlistctrl.DeleteAllItems();
		searchselect.ShowWindow(SW_HIDE);
		searchlistctrl.NoTabs();
	}
}

void CSearchDlg::DeleteAllSearchs()
{
	theApp.searchlist->Clear();
	searchlistctrl.DeleteAllItems();
	searchselect.ShowWindow(SW_HIDE);
	searchselect.DeleteAllItems();
}

void CSearchDlg::OnTcnSelchangeTab1(NMHDR *pNMHDR, LRESULT *pResult)
{
	TCITEM item;
	item.mask = TCIF_PARAM;
	int cur_sel = searchselect.GetCurSel();
	if (cur_sel == (-1))
		return;
	searchselect.GetItem(cur_sel,&item);
	searchlistctrl.ShowResults(item.lParam);
	*pResult = 0;
}

LRESULT CSearchDlg::OnCloseTab(WPARAM wparam, LPARAM lparam) {
	TCITEM item;
	item.mask = TCIF_PARAM;
	int i = (int)wparam;
	searchselect.GetItem(i,&item);
	int nSearchID = item.lParam;

	if ((!canceld) && (nSearchID == m_nSearchID))
		OnBnClickedCancels();  //Sony - cancel active search before closing active tab
	DeleteSearch(nSearchID);

	return true;
}

void CSearchDlg::OnEnChangeSearchname()
{
	GetDlgItem(IDC_STARTS)->EnableWindow(true);
	GetDlgItem(IDC_CANCELS)->EnableWindow(false);	
	GetDlgItem(IDC_CLEARALL)->EnableWindow(true);
}

void CSearchDlg::OnBnClickedSearchReset()
{
	GetDlgItem(IDC_EDITSEARCHAVAIBILITY)->SetWindowText("");	
	GetDlgItem(IDC_EDITSEARCHEXTENSION)->SetWindowText("");	
	GetDlgItem(IDC_EDITSEARCHMIN)->SetWindowText("");	
	GetDlgItem(IDC_EDITSEARCHMAX)->SetWindowText("");	
	GetDlgItem(IDC_SEARCHNAME)->SetWindowText("");
	Stypebox.SetCurSel(Stypebox.FindString(-1,GetResString(IDS_SEARCH_ANY)));

	OnEnChangeSearchname();
}

void CSearchDlg::OnStnClickedSearchextensionLbl()
{
	// TODO: Add your control notification handler code here
}

void CSearchDlg::OnEnChangeMethod()
{
	theApp.glob_prefs->SetMethod(methodbox.GetCurSel());
}

// START - enkeyDEV(Ottavio84) -Download all ed2ks in clipboard-
bool isprefix(const TCHAR* prefix, const TCHAR* string)
{
	while (_tcsnextc(prefix)) {
		if (_tcsnextc(prefix) != _tcsnextc(string))
			return false;
		prefix = _tcsinc(prefix);
		string = _tcsinc(string);
	}
	return true;
}

void CSearchDlg::OnBnClickedDownloadAllEd2k()
{
	CString clipboard = theApp.CopyTextFromClipboard();
	const TCHAR* text = clipboard;
	CString newlink;
	CString msglinks;
	CTypedPtrList<CPtrList, CED2KLink*> links;
	while (_tcsnextc(text)) {
		if (isprefix(_T("ed2k://"), text)) {
			bool bLinkEnded = false;
			TCHAR prevchar = 0;
			while (_tcsnextc(text)) {
				if (_tcsnextc(text) == '\n') {
					text = _tcsinc(text);
					continue;
				} else if (_tcsnextc(text) == '\r') {
					text = _tcsinc(text);
					continue;
				} else if (isprefix(_T("> "), text)) {
					text += _tcslen("> ");
					continue;
				} else if (_tcsnextc(text) == '>') {
					text = _tcsinc(text);
					continue;

				}
				newlink.AppendChar(_tcsnextc(text));

				TCHAR nextchar = _tcsnextc(_tcsinc(text));
				if ((_tcsnextc(text) == '/') && ((nextchar != _T('|')) && (nextchar != _T('/')))) // Link ends with "|/"
					bLinkEnded = true;

				if ((_tcsnextc(text) == '|') && (prevchar != '/') && _tcschr(_T(" \""), nextchar)) { // Link ends with "|"
					newlink.AppendChar(_T('/'));
					bLinkEnded = true;
				}

				if (bLinkEnded) {
					try {
						CED2KLink* pLink = CED2KLink::CreateLinkFromUrl(newlink);
						_ASSERT( pLink !=0 );
						if ( pLink->GetKind() == CED2KLink::kFile) {
							msglinks += newlink + "\n";
							links.AddTail(pLink);
						} else {
							delete pLink;
						}
					}
					catch(...) {}

					newlink = "";
					break;
				}
				prevchar = _tcsnextc(text);
				text = _tcsinc(text);
			}
		}
		text = _tcsinc(text);
	}
	if (links.IsEmpty()) {
		MessageBox(GetResString(IDS_ED2KNOLINKFROMCLIPBOARD)); //"No ED2K links found in clipboard"
	} else {
		CString msg;
		msg.Format(GetResString(IDS_ED2KCONFIRMFROMCLIPBOARD), msglinks); // "Add to downloads these links?\n%s", msglinks
		int retvalue = MessageBox(msg, NULL, MB_YESNO);
		if (retvalue == IDYES) {
			while (!links.IsEmpty()) {
				theApp.downloadqueue->AddFileLinkToDownload(links.GetHead()->GetFileLink());
				delete links.RemoveHead();
			}
		} else 
			while (!links.IsEmpty())
				delete links.RemoveHead();
	}
}
// END - enkeyDEV(Ottavio84) -Download all ed2ks in clipboard-
void CSearchDlg::OnDestroy()
{
	CResizableDialog::OnDestroy();
	//Resources cleanup - [TwoBottle Mod]
	DestroyIcon(GetSearchLstStatic()->SetIcon(oldSearchLstIcon));
}
